
$include (c8051f340.inc)                  ; Include register definition file

;-----------------------------------------------------------------------------
; EQUATES
;-----------------------------------------------------------------------------

CLK         equ P0.0
DATOS       equ P0.1
RESET				equ P0.3
BUSDATOS	  equ P1
BUSDIR			equ P2
TIMER1_INIT equ 2


; Scan codes (set 3)
SC_F1				equ 07h
ESC					equ 08h
TAB					equ 0dh
BSLASH			equ 0eh
F2					equ 0fh
LCONTROL		equ 11h
LMAYUS			equ 12h
MENORQUE		equ 13h
BLMAYUS			equ 14h
SC_Q				equ 15h
SC_1				equ 16h
F3					equ 17h
LALT				equ 19h
SC_Z				equ 1ah
SC_S				equ 1bh
SC_A				equ 1ch
SC_W				equ 1dh
SC_2				equ 1eh
F4					equ 1fh
SC_C				equ 21h
SC_X				equ 22h
SC_D				equ 23h
SC_E				equ 24h
SC_4				equ 25h
SC_3				equ 26h
F5					equ 27h
ESPACIO			equ 29h
SC_V				equ 2ah
SC_F				equ 2bh
SC_T				equ 2ch
SC_R				equ 2dh
SC_5				equ 2eh
F6					equ 2fh
SC_N				equ 31h
SC_B				equ 32h
SC_H				equ 33h
SC_G				equ 34h
SC_Y				equ 35h
SC_6				equ 36h
F7					equ 37h
RALT				equ 39h
SC_M				equ 3ah
SC_J				equ 3bh
SC_U				equ 3ch
SC_7				equ 3dh
SC_8				equ 3eh
F8					equ 3fh
COMA				equ 41h
SC_K				equ 42h
SC_I				equ 43h
SC_O				equ 44h
SC_0				equ 45h
SC_9				equ 46h
F9					equ 47h
PUNTO				equ 49h
MENOS				equ 4ah
SC_L				equ 4bh
SC_ENNE			equ 4ch
SC_P				equ 4dh
APOST				equ 4eh
F10					equ 4fh
LCORCH			equ 54h
ADMIR				equ 55h
F11					equ 56h
PRTSCR			equ 57h
RCONTROL		equ 58h
RMAYUS			equ 59h
INTRO				equ 5ah
RCORCH			equ 5bh
CEDILLA			equ 5ch
F12					equ 5eh
BLDESP			equ 5fh
ABAJO				equ 60h
IZQUIERDA		equ 61h
PAUSA				equ 62h
ARRIBA			equ 63h
SUPR				equ 64h
FIN					equ 65h
BACKSPACE		equ 66h
INS					equ 67h
KP1					equ 69h
DERECHA			equ 6ah
KP4					equ 6bh
KP7					equ 6ch
PGABAJO			equ 6dh
INICIO			equ 6eh
PGARRIBA		equ 6fh
KP0					equ 70h
KPPUNTO			equ 71h
KP2					equ 72h
KP5					equ 73h
KP6					equ 74h
KP8					equ 75h
BLNUM				equ 76h
KPBARRA			equ 77h
KPINTRO			equ 79h
KP3					equ 7ah
KPMAS				equ 7ch
KP9					equ 7dh
KPASTERISCO	equ 7eh
KPMENOS			equ 84h
LWINDOWS		equ 8bh
RWINDOWS		equ 8ch
APPS				equ 8dh


; ---------------------------------------------------------
; EQU's para las definiciones de las teclas en el Spectrum
; ---------------------------------------------------------


; LIT no est soportado por el A51, as que usamos #define, que s est soportado.

#define SP_1 		1,00001b
#define SP_2		1,00010b
#define SP_3		1,00100b
#define SP_4		1,01000b
#define SP_5		1,10000b

#define SP_Q		2,00001b
#define SP_W		2,00010b
#define SP_E		2,00100b
#define SP_R		2,01000b
#define SP_T		2,10000b

#define SP_A		3,00001b
#define SP_S		3,00010b
#define SP_D		3,00100b
#define SP_F		3,01000b
#define SP_G		3,10000b

#define SP_0		4,00001b
#define SP_9		4,00010b
#define SP_8		4,00100b
#define SP_7		4,01000b
#define SP_6		4,10000b

#define SP_P		5,00001b
#define SP_O		5,00010b
#define SP_I		5,00100b
#define SP_U		5,01000b
#define SP_Y		5,10000b

#define CAPS		6,00001b
#define SP_Z		6,00010b
#define SP_X		6,00100b
#define SP_C		6,01000b
#define SP_V		6,10000b

#define ENTER		7,00001b
#define SP_L		7,00010b
#define SP_K		7,00100b
#define SP_J		7,01000b
#define SP_H		7,10000b

#define SPACE		8,00001b
#define SYMBOL	8,00010b
#define SP_M		8,00100b
#define SP_N		8,01000b
#define SP_B		8,10000b

; ----------------------------------------------------------------------------
; MACROS
; ----------------------------------------------------------------------------

; Hace una traduccin de un scancode a una nica pulsacin de una tecla en el Spectrum
DefTecla 	macro scan,smf,valor
          local Pulsada,NoesEste

          cjne R6,#&scan,NoesEste

					mov A,Soltada
					jz Pulsada

					mov A,Sm&smf
					orl A,#&valor
					mov Sm&smf,A
					ljmp FinScans

Pulsada:  mov A,#&valor
          cpl A
					mov R6,A
					mov A,Sm&smf
					anl A,R6
					mov Sm&smf,A
					ljmp FinScans
					
NoesEste:
          endm 

; Hace una traduccin de un scancode a dos pulsaciones simultneas el Spectrum
DefTecla2	macro scan,smf,valor,smf2,valor2
          local Pulsada,NoesEste

          cjne R6,#&scan,NoesEste

					mov A,Soltada
					jz Pulsada

					mov A,Sm&smf
					orl A,#&valor
					mov Sm&smf,A

					mov A,Sm&smf2
					orl A,#&valor2
					mov Sm&smf2,A

					ljmp FinScans

Pulsada:  mov A,#&valor
          cpl A
					mov R6,A
					mov A,Sm&smf
					anl A,R6
					mov Sm&smf,A

					mov A,#&valor2
          cpl A
					mov R6,A
					mov A,Sm&smf2
					anl A,R6
					mov Sm&smf2,A

					ljmp FinScans
					
NoesEste:
          endm 

; Traduce un scancode simple del set 2 al set 3
Traduce   macro sm2,sm3
					local NoEsEsta
          cjne R6,#&sm2,NoEsEsta
					mov LastK,#&sm3
					ajmp FinTradSm2
NoEsEsta:
					endm

; Traduce un scancode extendido (con E0) del set 2 al set 3
TraduceEx macro sm2,sm3
					local NoEsEsta
          cjne R6,#&sm2,NoEsEsta
					mov LastK,#&sm3
					ajmp FinTradEx
NoEsEsta:
					endm


; Incluye la informacin de una semifila si el bit 0 de A es 0.
IncSemif	macro semf
					local NoIncEsta
          rrc A							; 1
					jc NoIncEsta			; 3

					xch A,R5					; 1
					mov A,Sm&semf			; 2
					anl A,R6					; 1
					mov R6,A					; 1
					xch A,R5					; 1
NoIncEsta:
					endm							; Total en el peor caso: 10 ciclos


; Enva un byte al teclado y espera ACK
Transmite macro comando
					local Trans,TransOK
					mov R4,#0
Trans:    mov R6,comando
          lcall Transmitir
					lcall WaitK
					cjne R6,#0feh,TransOK
					sjmp Trans
TransOK:
					endm


; Enva un byte al teclado sin esperar respuesta
TrNoPausa macro comando
					mov R4,#0
          mov R6,comando
          lcall Transmitir
					endm


; Enva un byte al teclado y espera un ratito
TrPausa   macro comando
					mov R4,#0
          mov R6,comando
          lcall Transmitir
					mov A,#10
					lcall mDelay
					endm


ProcessFx macro scf,buffer
          local NoesEstaF,PlayF
          cjne R6,#scf, NoesEstaF
					mov A,Soltada
					jz NoesEstaF

					TrNoPausa #0edh
					mov A,Leds
					orl A,#4
					mov Leds,A
					TrNoPausa A

					mov DPTR,#buffer
					mov IndexGrab,#0
          mov R2,MacroRec
					cjne R2,#0ffh,PlayF

					mov MacroRec,#1
					mov MacroPlay,#0
					ajmp FinEspeciales

PlayF:    mov MacroPlay,#1
					mov MacroRec,#0
					setb TR1  ; Habilitar timer 1
					ajmp FinEspeciales

NoesEstaF:
					endm

; Espera un periodo completo de bajo y alto.
DeBajoaAlto macro
            local Sigoa0,Sigoa1
Sigoa0: 		jnb CLK,Sigoa0
Sigoa1:			jb CLK,Sigoa1
						endm

;-----------------------------------------------------------------------------
; SIMBOLOS EXTERNOS
;-----------------------------------------------------------------------------
extrn code (Init_Device)

;-----------------------------------------------------------------------------
; SEGMENTO DE DATOS
;-----------------------------------------------------------------------------

            dseg at 30h   ; Segmento de datos RAM
LastK:      ds 1          ; Ultimo SCAN KEY
ScanMode:   ds 1          ; Modo de scan actual del teclado
Soltada:    ds 1          ; Pulsado o soltado
Extendida:  ds 1					; Solo para scan set 2: indica si el codigo es extendido.

CuentaTim1: ds 1          ; Prescaler software timer 1 (15 Hz)
MacroPlay:  ds 1					; 0 si no hay macro reproduciendose. 1-8 si la hay
MacroRec:   ds 1          ; 0 si no hay macro grabandose. 1-8 si la hay
IndexGrab:  ds 1          ; Indice al byte a leer/escribir de la macro de teclado

Ctrl:				ds 1          ; CTRL pulsada
Alt:        ds 1					; ALT pulsada
Del:	  		ds 1					; SUPR pulsada
Mayus:			ds 1					; MAYUS pulsada
ModoJoy:    ds 1          ; Indica si hemos pasado a modo joystick Sinclair
Leds:       ds 1					; Estado de los leds del teclado

Sm1:        ds 1
Sm2:        ds 1
Sm3:        ds 1
Sm4:        ds 1
Sm5:        ds 1
Sm6:        ds 1
Sm7:        ds 1
Sm8:        ds 1

;-----------------------------------------------------------------------------
; RESET and INTERRUPT VECTORS
;-----------------------------------------------------------------------------

            ; Reset Vector
            cseg at 0
            ljmp Main                     

						; INT0
						cseg at 03h
						mov BUSDATOS, #0ffh   ; Por si acaso a la ULA le da por leer mientras estamos en esto
						ljmp Int0Handl

						; Timer1
						cseg at 1bh
						mov BUSDATOS,#0ffh
						ljmp Timer1Handl

;-----------------------------------------------------------------------------
; CODE SEGMENT
;-----------------------------------------------------------------------------

Teclado     segment  CODE

            rseg     Teclado              ; Switch to this code segment.
            using    0                    ; Specify register bank for the
                                          ; following program code.
Main:
            ; Disable the WDT.
            anl   PCA0MD, #NOT(040h)      ; clear Watchdog Enable bit

            mov R7,#0                     ; R7 = contador bits teclado
            mov R6,#0                     ; R6 = ultimo valor leido del teclado o valor a transmitir
						mov R5,#0                     ; R5 = cuenta los 'unos' leidos para la paridad
						mov R4,#0											; R4 = flag que indica si hay tecla pulsada

            ; Iniciamos variables
						mov LastK,#0
						mov Soltada,#0
						mov Extendida,#0
						mov Ctrl,#0
						mov Alt,#0
						mov Supr,#0
						mov Mayus,#0
						mov ModoJoy,#0

						mov CuentaTim1,#TIMER1_INIT
						mov MacroPlay,#0
						mov MacroRec,#0
						mov IndexGrab,#0

            ; Iniciamos semifilas al valor "ninguna tecla pulsada"
						mov Sm1,#0ffh
						mov Sm2,#0ffh
						mov Sm3,#0ffh
						mov Sm4,#0ffh
						mov Sm5,#0ffh
						mov Sm6,#0ffh
						mov Sm7,#0ffh
						mov Sm8,#0ffh

						lcall Init_Device

						mov BUSDATOS, #0ffh
						mov BUSDIR,#0ffh
						setb CLK
						setb DATOS
						setb RESET

						lcall InitXRAM
           
            mov R6,#0ffh    ; Reset software al teclado
						acall Transmitir

						; Bucle principal: lee y actualiza constantemente los bits D0 a D4 en el bus de datos del
						; teclado en la ULA. En el F343 esto lleva alrededor de 270 nanosegundos por actualizacin.
Bucle:      mov R1,BUSDIR					; 2 c.
						movx A,@R1				 		; 3 c.
						mov BUSDATOS,A				; 2 c.
						cjne R4,#0, ProcesaKey; 3 c
						sjmp Bucle						; 3 c.

; --------------------------------------------------------------------------------
; Rutina para procesar los eventos de teclado recibidos.
; Se encarga de responder al RESET de teclado, hacer la traduccin de scan set 2 a
; scan set 3 si hiciera falta, y por ultimo, decodificar la tecla pulsada
; --------------------------------------------------------------------------------

ProcesaKey: mov BUSDATOS, #0ffh
            mov R4,#0
            mov R6,LastK
						cjne R6,#0aah,NoProcesaRESET
						acall Init_Teclado
						sjmp Bucle

NoProcesaRESET:
            clr CLK
						acall DecoKEY
						setb CLK
						sjmp Bucle

; --------------------------------------------------------------------------------
; RUTINA PARA ENVIAR UN BYTE AL TECLADO.
; ESTA RUTINA INHIBE TODAS LAS INTERRUPCIONES Y PONE UN #FF EN EL BUS DE DATOS POR SI OCURRE UNA LECTURA DE LA ULA
; MIENTRAS SE ENVIA EL COMANDO AL TECLADO.
; R6 contiene el dato a enviar.
; R7 es el contador de bits
; --------------------------------------------------------------------------------

Transmitir: anl IE, #NOT(080h)    ; Sin interrupciones
						mov R5,#0             ; Contador de 'unos' para la paridad
						mov R7,#8

            ; 1. Poner CLK bajo durante al menos 160 us, y DATOS unos 30us despus de bajar CLK
						setb DATOS
						clr CLK

						mov A,#60
            acall uDelay

						clr DATOS

						mov A,#100
            acall uDelay

            ; 2. Liberar reloj
            setb CLK

            ; 3a. Esperar pulso bajo y enviar un 0 (bit de start)
						DeBajoaAlto

						; 3b. Esperar pulso bajo e ir enviando bits
						mov A,R6
OtroBit:    rrc A
						mov DATOS, C
						DeBajoaAlto
						djnz R7, OtroBit

            ; 4. Enviar paridad
            mov A,R6
						mov C, PSW.0
            cpl C
						mov DATOS, C
						DeBajoaAlto

            ; 5. Liberar datos (bit de STOP)
						setb DATOS
						DeBajoaAlto
					  DeBajoaAlto
						; aqui recogemoe en C el ACK dado por el teclado
						mov C, DATOS

						orl IE, #080h   ; Interrupciones habilitadas de nuevo

						ret
; --------------------------------------------------------------------------------
; Rutina que espera los us que especifiquemos
; Entrada: A es el numero de us a esperar
; Esta rutina est calibrada para un reloj de 48MHz
; --------------------------------------------------------------------------------
uDelay:     nop
            nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
            nop
						nop
            nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
						nop
            nop
						dec A
						jnz uDelay
						ret

; --------------------------------------------------------------------------------
; Rutina que espera los ms que especifiquemos
; Entrada: A es el numero de ms a esperar
; --------------------------------------------------------------------------------
mDelay:     xch A,R2
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            mov A,#200
						acall uDelay
            xch A,R2
						dec A
						jnz mDelay
						ret

; --------------------------------------------------------------------------------
; Esperar a respuesta del teclado
; Vuelve con R6 = ltimo cdigo recibido
; --------------------------------------------------------------------------------
WaitK:      cjne R4,#1,WaitK
						mov R6,LastK
						mov R4,#0
						ret

; --------------------------------------------------------------------------------
; Rutina para inicializar el teclado
; Pone el modo scan 3 y activa Bloq Num.
; Se activa desde el gestor de interrupciones, en respuesta a la seal de RESET
; --------------------------------------------------------------------------------
Init_Teclado: ;SCAN SET 3
						Transmite #0f0h
            TrPausa #3

						; Preguntamos por el scan set actual
						Transmite #0f0h
						Transmite #0
						acall WaitK
						mov ScanMode,R6

            cjne R6,#3, ProgModo2

            ; MAKE / BREAK para todas las teclas
						Transmite #0f8h
						sjmp Fin_InitTec

ProgModo2:  Transmite #0f6h   ; Cargamos valores por defecto
            Transmite #0f3h   ; Cargamos 1 seg de antes de rep. y 0,5 seg. de autorrepeat
						Transmite #7fh

            ; BLOQ NUM activado
Fin_InitTec:Transmite #0edh
					  Transmite #2
						mov Leds,#2
						mov ModoJoy,#0

						; Habilitar escaneo del teclado
						TrPausa #0f4h

					  ret
; --------------------------------------------------------------------------------
; Rutina principal de decodificacin de tecla AT -> Speccy
; LastK = tecla a decodificar
; Soltada = estado de la pulsacin
; --------------------------------------------------------------------------------
DecoKEY:    ;Primero se descartan los scancode especiales para no perder tiempo
						mov R6,LastK
						cjne R6,#0f0h,NoesF0
						ret
NoesF0:			cjne R6,#0e0h,NoesE0
						ret
NoesE0:     cjne R6,#0fah,NoesFA
						ret
NoesFA:			cjne R6,#0feh,NoesFE
						ret
NoesFE:
						;Despues se traduce el codigo de scan al modo 3, si es que estamos en modo 2
      			mov R6,ScanMode
						cjne R6,#2,NoTraducir
						lcall TradKey

            ;Despus se graba si hay activa una grabacion de macro
NoTraducir:	mov R6,MacroRec
						cjne R6,#1,NoGrabar
						mov A,LastK
						movx @DPTR,A
						inc DPTR
						mov A,Soltada
						movx @DPTR,A
						inc DPTR
						inc IndexGrab
						mov R6,IndexGrab
						cjne R6,#0ffh,NoBufLleno
					  lcall StopGrab	
NoBufLleno:

						;Despues se procesan las teclas especiales y se comprueban las combinanciones especiales
NoGrabar:   mov R6,LastK
						cjne R6, #LCONTROL, NoesLCtrl
						mov A, Soltada
						xrl A,#1
						mov Ctrl,A
						ajmp FinEspeciales

NoesLCtrl:  cjne R6,#RCONTROL, NoesRCtrl
						mov A, Soltada
						xrl A,#1
						mov Ctrl,A
						ajmp FinEspeciales

NoesRCtrl:  cjne R6,#LALT, NoesLAlt
						mov A, Soltada
						xrl A,#1
            mov Alt,A
						ajmp FinEspeciales
						
NoesLAlt:   cjne R6,#RALT, NoesRAlt
						mov A, Soltada
						xrl A,#1
            mov Alt,A
						ajmp FinEspeciales
						
NoesRAlt:   cjne R6,#SUPR, NoesSupr1
						mov A, Soltada
						xrl A,#1
            mov Del,A
						ajmp FinEspeciales
						
NoesSupr1:	cjne R6,#KPPUNTO, NoesSupr2
						mov A, Soltada
						xrl A,#1
            mov Del,A
						ajmp FinEspeciales					
						
NoesSupr2:  cjne R6,#LMAYUS, NoesLMayus
						mov A, Soltada
						xrl A,#1
            mov Mayus,A
						ajmp FinEspeciales
						
NoesLMayus: cjne R6,#RMAYUS, NoesRMayus
						mov A, Soltada
						xrl A,#1
            mov Mayus,A
						ajmp FinEspeciales

NoesRMayus: cjne R6,#BLDESP, NoesBlDesp
            mov A,Soltada
						jnz NoesBlDesp
            mov A,ModoJoy
						cpl A
						mov ModoJoy,A
					  TrNoPausa #0edh
						mov A,Leds
						xrl A,#1
						mov Leds,A
					  TrNoPausa A
						mov R6,LastK
						ajmp FinEspeciales

NoesBlDesp: cjne R6,#F3, NoEsF3
						mov A,Soltada
						jnz NoEsF3
            mov MacroRec,#0ffh
						ajmp FinEspeciales

NoEsF3:     cjne R6,#F4, NoEsF4
						mov A,Soltada
						jnz NoEsF4
            mov R2,MacroRec
						cjne R2,#0,PararGrab
						ajmp FinEspeciales
PararGrab:	lcall StopGrab
						ajmp FinEspeciales

NoEsF4:     ProcessFx F5,1024
            ProcessFx F6,1024+512
						ProcessFx F7,2048
						ProcessFx F8,2048+512
						ProcessFx F9,3072
						ProcessFx F10,3072+512

FinEspeciales:
            mov A,Ctrl
						anl A,Alt
						anl A,Del
						jz NoReset

						clr RESET
						mov A,#0
						call uDelay     ; Pulso de RESET de unos 250 us al Spectrum
						setb RESET
						mov Ctrl,#0
						mov Alt,#0
						mov Del,#0
						sjmp FinComb

NoReset:

FinComb:    DefTecla2 ESC,CAPS,SPACE
            DefTecla2 TAB,CAPS,SYMBOL
						DefTecla2 F2,CAPS,SP_1
						DefTecla2 BSLASH,SYMBOL,SP_D
            DefTecla2 BLMAYUS,CAPS,SP_2
            DefTecla2 RALT,CAPS,SP_9
						DefTecla2 BACKSPACE,CAPS,SP_0

						DefTecla  SC_Q,SP_Q
						DefTecla  SC_W,SP_W
						DefTecla  SC_E,SP_E
						DefTecla  SC_R,SP_R
						DefTecla  SC_T,SP_T
						DefTecla  SC_Y,SP_Y
						DefTecla  SC_U,SP_U
						DefTecla  SC_I,SP_I
						DefTecla  SC_O,SP_O
						DefTecla  SC_P,SP_P

						DefTecla  SC_A,SP_A
						DefTecla  SC_S,SP_S
						DefTecla  SC_D,SP_D
						DefTecla  SC_F,SP_F
						DefTecla  SC_G,SP_G
						DefTecla  SC_H,SP_H
						DefTecla  SC_J,SP_J
						DefTecla  SC_K,SP_K
						DefTecla  SC_L,SP_L
						DefTecla2 CEDILLA,SYMBOL,SP_P
						DefTecla  INTRO,ENTER

						DefTecla  SC_Z,SP_Z
						DefTecla  SC_X,SP_X
						DefTecla  SC_C,SP_C
						DefTecla  SC_V,SP_V
						DefTecla  SC_B,SP_B
						DefTecla  SC_N,SP_N
						DefTecla  SC_M,SP_M
						DefTecla  ESPACIO,SPACE

						DefTecla  KP0,SP_0
						DefTecla  KP1,SP_1
						DefTecla  KP2,SP_2
						DefTecla  KP3,SP_3
						DefTecla  KP4,SP_4
						DefTecla  KP5,SP_5
						DefTecla  KP6,SP_6
						DefTecla  KP7,SP_7
						DefTecla  KP8,SP_8
						DefTecla  KP9,SP_9
						DefTecla2 KPBARRA,SYMBOL,SP_V
						DefTecla2 KPASTERISCO,SYMBOL,SP_B
						DefTecla2 KPMENOS,SYMBOL,SP_J
						DefTecla2 KPMAS,SYMBOL,SP_K
						DefTecla2 KPPUNTO,SYMBOL,SP_M
						DefTecla  KPINTRO,ENTER

						mov R0,Mayus
						cjne R0,#0,PonShift
						lcall SinShift
						ajmp FinShift
PonShift:		lcall ConShift
FinShift:

						mov R0,ModoJoy
						cjne R0,#0,PonModoJoy
						lcall PonCursores
						ajmp FinModoJoy
PonModoJoy: lcall PonSinclair
FinModoJoy:

FinScans:   
						mov R0,#0
BucFillX: 	mov R6,#0ffh
						mov A,R0
						IncSemif 1      ; CUIDADO! Esto es porque los cables estn as.
						IncSemif 2
						IncSemif 3
						IncSemif 4
						IncSemif 5
						IncSemif 6
						IncSemif 7
						IncSemif 8
						mov A,R6
						movx @R0,A
						inc R0
						cjne R0,#0ffh,BucFillX

						mov Soltada,#0  
						mov Extendida,#0   ; Una vez procesada la tecla, se borran las banderas
            ret

PonCursores:
						DefTecla2 ARRIBA,CAPS,SP_7
						DefTecla2 ABAJO,CAPS,SP_6
						DefTecla2 IZQUIERDA,CAPS,SP_5
						DefTecla2 DERECHA,CAPS,SP_8
            DefTecla  LCONTROL,CAPS
            DefTecla  RCONTROL,SYMBOL
						ret
						
PonSinclair:
						DefTecla ARRIBA,SP_9
						DefTecla ABAJO,SP_8
						DefTecla DERECHA,SP_7
						DefTecla IZQUIERDA,SP_6
						DefTecla LCONTROL,SP_0
						DefTecla RCONTROL,SP_0
						ret						            

SinShift:   DefTecla  SC_1,SP_1
						DefTecla  SC_2,SP_2
						DefTecla  SC_3,SP_3
						DefTecla  SC_4,SP_4
						DefTecla  SC_5,SP_5
						DefTecla  SC_6,SP_6
						DefTecla  SC_7,SP_7
						DefTecla  SC_8,SP_8
						DefTecla  SC_9,SP_9
						DefTecla  SC_0,SP_0
						DefTecla2 APOST,SYMBOL,SP_7
						DefTecla2 ADMIR,SYMBOL,SP_1
						DefTecla2 LCORCH,SYMBOL,SP_Y
						DefTecla2 RCORCH,SYMBOL,SP_K
						DefTecla2 COMA,SYMBOL,SP_N
						DefTecla2 PUNTO,SYMBOL,SP_M
						DefTecla2 MENOS,SYMBOL,SP_J
						DefTecla2 MENORQUE,SYMBOL,SP_R
						ret

ConShift:   DefTecla2 SC_1,SYMBOL,SP_1
						DefTecla2 SC_2,SYMBOL,SP_P
						DefTecla2 SC_3,SYMBOL,SP_3
						DefTecla2 SC_4,SYMBOL,SP_4
						DefTecla2 SC_5,SYMBOL,SP_5
						DefTecla2 SC_6,SYMBOL,SP_6
						DefTecla2 SC_7,SYMBOL,SP_V
						DefTecla2 SC_8,SYMBOL,SP_8
						DefTecla2 SC_9,SYMBOL,SP_9
						DefTecla2 SC_0,SYMBOL,SP_L
						DefTecla2 APOST,SYMBOL,SP_C
						DefTecla2 LCORCH,SYMBOL,SP_H
						DefTecla2 RCORCH,SYMBOL,SP_B
						DefTecla2 COMA,SYMBOL,SP_O
						DefTecla2 PUNTO,SYMBOL,SP_Z
						DefTecla2 MENOS,SYMBOL,SP_0
						DefTecla2 MENORQUE,SYMBOL,SP_T
						ret

; --------------------------------------------------------------------------------
; Rutina de traduccin de Scan mode 2 a Scan mode 3
; LastK = tecla a decodificar
; Soltada = estado de la pulsacin
; --------------------------------------------------------------------------------
TradKey:    mov R6,LastK
						mov R5,Extendida
						cjne R5,#1,NoTradExt

						acall TradExt
						ajmp FinTradSm2

NoTradExt:  Traduce 58h,14h ; CAPS
            Traduce 5dh,5ch ; \
						Traduce 14h,11h ; LCTRL
						Traduce 11h,19h ; LALT
						Traduce 77h,76h ; BLNUM
						Traduce 61h,13h ; <
						Traduce 7ch,7eh ; *
						Traduce 7bh,84h ; -
						Traduce 79h,7ch ; +
						Traduce 76h,08h ; ESC
						Traduce 05h,07h ; F1
						Traduce 06h,0fh ; F2
						Traduce 04h,17h ; F3
						Traduce 0ch,1fh ; F4
						Traduce 03h,27h ; F5
						Traduce 0bh,2fh ; F6
						Traduce 83h,37h ; F7
						Traduce 0ah,3fh ; F8
						Traduce 01h,47h ; F9
						Traduce 09h,4fh ; F10
						Traduce 78h,56h ; F12
						Traduce 7eh,5fh ; BLDESP
FinTradSm2: ret

TradExt:  	TraduceEx 1fh,8bh ; LGUI
						TraduceEx 14h,58h ; RCTRL
						TraduceEx 27h,8ch ; RGUI
						TraduceEx 11h,39h ; RALT
						TraduceEx 2fh,8dh ; APPS
						TraduceEx 70h,67h ; INS
						TraduceEx 6ch,6eh ; INICIO
						TraduceEx 7dh,6fh ; PGARR
						TraduceEx 71h,64h ; SUPR
						TraduceEx 69h,65h ; FIN
						TraduceEx 7ah,6dh ; PGABJ
						TraduceEx 75h,63h ; ARRIBA
						TraduceEx 6bh,61h ; IZQUIERDA
						TraduceEx 72h,60h ; ABAJO
						TraduceEx 74h,6ah ; DERECHA
						TraduceEx 4ah,77h ; /
						TraduceEx 5ah,79h ; ENTER
FinTradEx:  ret


; --------------------------------------------------------------------------------
; Rutina para rellenar la XRAM a 0
; --------------------------------------------------------------------------------
InitXRAM:   mov R0,#00h
            mov A,#0ffh
BucInitX:   movx @R0,A
            inc R0
						cjne R0,#0,BucInitX


; --------------------------------------------------------------------------------
; Gestor de interrupcin de INT0
; --------------------------------------------------------------------------------
Int0Handl:  inc R7

  					cjne R7,#1, NoBitStart
						mov R6,#0
						jnb DATOS, StartVal
						mov R7,#0
StartVal:		mov R5,#0
						mov R4,#0
            reti

NoBitStart: cjne R7,#0ah, NoPar
            inc R5
						jb DATOS, NoDecR5
						dec R5
NoDecR5:  	reti

NoPar:      cjne R7,#0bh, NoBitStop
            jnb DATOS, NoDatoVal
						xch A,R5
						anl A,#1
						xch A,R5
						cjne R5,#1, NoDatoVal

            ; En R6 tenemos nuestro dato!!
						; Hacer lo que sea con l

						cjne R6,#0e0h,NoExtendida
						mov Extendida,#1
						mov R4,#0  ; E0 no se toma como pulsacin an
						sjmp FinRec

NoExtendida:cjne R6,#0f0h,TeclaPul
						mov Soltada,#1
						mov R4,#0  ; F0 no se toma como pulsacin an
						sjmp FinRec

TeclaPul:	  mov LastK,R6
						mov R4,#1  ; Tenemos nuevo scancode!
						;mov MacroPlay,#0 ; Paramos cualquier macro que estuviera en reproduccion

FinRec:

NoDatoVal:	mov R7,#0
						reti

NoBitStop:  setb C
            inc R5
            jb DATOS,SigBit
						clr C
						dec R5
SigBit:     xch A,R6
            rrc A
            xch A,R6

						reti


; --------------------------------------------------------------------------------
; Gestor de interrupcin de TIMER 1 overflow
; --------------------------------------------------------------------------------
Timer1Handl:dec CuentaTim1
            mov A,CuentaTim1
						jz Tick
            reti

Tick:       mov CuentaTim1, #TIMER1_INIT

						mov A,MacroPlay
						jz FinPlay

            movx A,@DPTR
						cjne A,#0ffh,NoFinPlay

FinPlay:		mov MacroPlay,#0
						clr TR1
						TrNoPausa #0edh
						mov A,Leds
						anl A,#3
						mov Leds,A
						TrNoPausa A
						reti

NoFinPlay:  mov LastK,A
            inc DPTR
						movx A,@DPTR
						mov Soltada,A
						inc DPTR
						lcall DecoKey
						reti


StopGrab:   TrNoPausa #0edh
						mov A,Leds
						anl A,#3
						mov Leds,A
						TrNoPausa A
						;Marcar fin de grabacion en la macro
						mov A,#0ffh
						movx @DPTR,A
						inc DPTR
						movx @DPTR,A
						inc DPTR
						mov MacroRec,#0
						mov IndexGrab,#0
            ret

END

